aboutsummaryrefslogtreecommitdiff
path: root/sysdeps
diff options
context:
space:
mode:
Diffstat (limited to 'sysdeps')
-rw-r--r--sysdeps/mach/alpha/machine-lock.h10
-rw-r--r--sysdeps/mach/configure49
-rw-r--r--sysdeps/mach/hurd/alpha/tls.h53
-rwxr-xr-xsysdeps/mach/hurd/configure10
-rw-r--r--sysdeps/powerpc/powerpc64/dl-machine.h164
-rw-r--r--sysdeps/powerpc/powerpc64/dl-tls.h40
-rw-r--r--sysdeps/unix/sysv/linux/configure12
-rw-r--r--sysdeps/unix/sysv/linux/dl-librecon.h7
8 files changed, 306 insertions, 39 deletions
diff --git a/sysdeps/mach/alpha/machine-lock.h b/sysdeps/mach/alpha/machine-lock.h
index 80f8750c87..363c29e56f 100644
--- a/sysdeps/mach/alpha/machine-lock.h
+++ b/sysdeps/mach/alpha/machine-lock.h
@@ -1,5 +1,5 @@
/* Machine-specific definition for spin locks. Alpha version.
- Copyright (C) 1994, 1997 Free Software Foundation, Inc.
+ Copyright (C) 1994,97,2002 Free Software Foundation, Inc.
This file is part of the GNU C Library.
The GNU C Library is free software; you can redistribute it and/or
@@ -38,8 +38,8 @@ typedef __volatile long int __spin_lock_t;
_EXTERN_INLINE void
__spin_unlock (__spin_lock_t *__lock)
{
- __asm__ __volatile__ ("mb; stq $31, %0; mb"
- : "=m" (__lock));
+ __asm__ __volatile__ ("mb");
+ *__lock = 0;
}
/* Try to lock LOCK; return nonzero if we locked it, zero if another has. */
@@ -47,6 +47,9 @@ __spin_unlock (__spin_lock_t *__lock)
_EXTERN_INLINE int
__spin_try_lock (register __spin_lock_t *__lock)
{
+#if 1
+ return 1;
+#else
register long int __rtn, __tmp;
do
@@ -66,6 +69,7 @@ __spin_try_lock (register __spin_lock_t *__lock)
} while (! __rtn);
/* RTN is now nonzero; we have the lock. */
return __rtn;
+#endif
}
/* Return nonzero if LOCK is locked. */
diff --git a/sysdeps/mach/configure b/sysdeps/mach/configure
index 597a0a5b1b..6fd414845f 100644
--- a/sysdeps/mach/configure
+++ b/sysdeps/mach/configure
@@ -102,7 +102,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -148,7 +148,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -193,6 +193,12 @@ else
#line $LINENO "configure"
#include "confdefs.h"
#include <mach/mach_types.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
@@ -235,6 +241,12 @@ else
#line $LINENO "configure"
#include "confdefs.h"
#include <mach/mach_types.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
@@ -278,6 +290,12 @@ else
#line $LINENO "configure"
#include "confdefs.h"
#include <mach/task_info.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
@@ -336,7 +354,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -372,21 +390,6 @@ echo "$as_me: error: what manner of Mach is this?" >&2;}
{ (exit 1); exit 1; }; }
fi
-echo "$as_me:$LINENO: checking for egrep" >&5
-echo $ECHO_N "checking for egrep... $ECHO_C" >&6
-if test "${ac_cv_prog_egrep+set}" = set; then
- echo $ECHO_N "(cached) $ECHO_C" >&6
-else
- if echo a | (grep -E '(a|b)') >/dev/null 2>&1
- then ac_cv_prog_egrep='grep -E'
- else ac_cv_prog_egrep='egrep'
- fi
-fi
-echo "$as_me:$LINENO: result: $ac_cv_prog_egrep" >&5
-echo "${ECHO_T}$ac_cv_prog_egrep" >&6
- EGREP=$ac_cv_prog_egrep
-
-
echo "$as_me:$LINENO: checking for host_page_size in mach_host.defs" >&5
echo $ECHO_N "checking for host_page_size in mach_host.defs... $ECHO_C" >&6
if test "${libc_cv_mach_host_page_size+set}" = set; then
@@ -399,7 +402,7 @@ else
_ACEOF
if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
- $EGREP "host_page_size" >/dev/null 2>&1; then
+ egrep "host_page_size" >/dev/null 2>&1; then
libc_cv_mach_host_page_size=yes
else
libc_cv_mach_host_page_size=no
@@ -429,7 +432,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -469,7 +472,7 @@ _ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
- grep -v '^ *+' conftest.er1 >conftest.err
+ egrep -v '^ *\+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
@@ -514,7 +517,7 @@ else
_ACEOF
if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
- $EGREP "i386_io_perm_modify" >/dev/null 2>&1; then
+ egrep "i386_io_perm_modify" >/dev/null 2>&1; then
libc_cv_mach_i386_ioports=yes
else
libc_cv_mach_i386_ioports=no
@@ -543,7 +546,7 @@ else
_ACEOF
if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
- $EGREP "i386_set_gdt" >/dev/null 2>&1; then
+ egrep "i386_set_gdt" >/dev/null 2>&1; then
libc_cv_mach_i386_gdt=yes
else
libc_cv_mach_i386_gdt=no
diff --git a/sysdeps/mach/hurd/alpha/tls.h b/sysdeps/mach/hurd/alpha/tls.h
new file mode 100644
index 0000000000..e820a013bf
--- /dev/null
+++ b/sysdeps/mach/hurd/alpha/tls.h
@@ -0,0 +1,53 @@
+/* Definition for thread-local data handling. Hurd/Alpha version.
+ Copyright (C) 2002 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Lesser General Public License for more details.
+
+ You should have received a copy of the GNU Lesser General Public
+ License along with the GNU C Library; if not, write to the Free
+ Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+ 02111-1307 USA. */
+
+#ifndef _TLS_H
+#define _TLS_H
+
+#if defined HAVE_TLS_SUPPORT && 0
+
+/* Signal that TLS support is available. */
+# define USE_TLS 1
+
+/* Code to initially initialize the thread pointer. This might need
+ special attention since 'errno' is not yet available and if the
+ operation can cause a failure 'errno' must not be touched. */
+# define TLS_INIT_TP(descr) \
+ do \
+ { \
+ register tcbhead_t *_a0 __asm__ ("$16") = (descr); \
+ __asm__ ("call_pal %0" : : "i" (PAL_wruniq), "r" (_a0)); \
+ } while (0)
+
+# define THREAD_TCB() \
+ ({ \
+ register tcbhead_t *_rv __asm__ ("$0"); \
+ __asm__ ("call_pal %0" : "=r" (rv) : "i" (PAL_rduniq)); \
+ _rv; \
+ })
+
+/* Install new dtv for current thread. */
+# define INSTALL_NEW_DTV(dtv) (THREAD_DTV () = (dtv))
+
+/* Return the address of the dtv for the current thread. */
+# define THREAD_DTV() (THREAD_TCB ()->dtv)
+
+#endif /* HAVE_TLS_SUPPORT */
+
+#endif /* tls.h */
diff --git a/sysdeps/mach/hurd/configure b/sysdeps/mach/hurd/configure
index 86239bb483..07f62b87c4 100755
--- a/sysdeps/mach/hurd/configure
+++ b/sysdeps/mach/hurd/configure
@@ -27,16 +27,22 @@ case "$machine" in
;;
esac
-
echo "$as_me:$LINENO: checking Hurd header version" >&5
echo $ECHO_N "checking Hurd header version... $ECHO_C" >&6
if test "${libc_cv_hurd_version+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
- cat >conftest.$ac_ext <<_ACEOF
+
+cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
#include "confdefs.h"
#include <hurd/version.h>
+#ifdef F77_DUMMY_MAIN
+# ifdef __cplusplus
+ extern "C"
+# endif
+ int F77_DUMMY_MAIN() { return 1; }
+#endif
int
main ()
{
diff --git a/sysdeps/powerpc/powerpc64/dl-machine.h b/sysdeps/powerpc/powerpc64/dl-machine.h
index 62e7f22c6b..7d7e78677a 100644
--- a/sysdeps/powerpc/powerpc64/dl-machine.h
+++ b/sysdeps/powerpc/powerpc64/dl-machine.h
@@ -328,9 +328,19 @@ elf_machine_dynamic (void)
PLT entries should not be allowed to define the value.
ELF_RTYPE_CLASS_NOCOPY iff TYPE should not be allowed to resolve to one
of the main executable's symbols, as for a COPY reloc. */
+
+#if defined USE_TLS && (!defined RTLD_BOOTSTRAP || USE___THREAD)
+#define elf_machine_type_class(type) \
+ ( (((type) == R_PPC64_DTPMOD64 \
+ || (type) == R_PPC64_DTPREL64 \
+ || (type) == R_PPC64_TPREL64 \
+ || (type) == R_PPC64_ADDR24) * ELF_RTYPE_CLASS_PLT) \
+ | (((type) == R_PPC64_COPY) * ELF_RTYPE_CLASS_COPY))
+#else
#define elf_machine_type_class(type) \
((((type) == R_PPC64_ADDR24) * ELF_RTYPE_CLASS_PLT) \
| (((type) == R_PPC64_COPY) * ELF_RTYPE_CLASS_COPY))
+#endif
/* A reloc type used for ld.so cmdline arg lookups to reject PLT entries. */
#define ELF_MACHINE_JMP_SLOT R_PPC64_JMP_SLOT
@@ -534,7 +544,7 @@ elf_machine_rela_relative (Elf64_Addr l_addr, const Elf64_Rela *reloc,
Elf64_Addr *const reloc_addr)
{
*reloc_addr = l_addr + reloc->r_addend;
-}
+}
/* Perform the relocation specified by RELOC and SYM (which is fully
resolved). MAP is the object containing the reloc. */
@@ -547,7 +557,7 @@ elf_machine_rela (struct link_map *map,
{
int r_type = ELF64_R_TYPE (reloc->r_info);
struct link_map *sym_map;
- Elf64_Addr value;
+ Elf64_Addr value, raw_value;
#ifndef RTLD_BOOTSTRAP
const Elf64_Sym *const refsym = sym;
/* This is defined in rtld.c, but nowhere in the static libc.a; make the
@@ -564,28 +574,80 @@ elf_machine_rela (struct link_map *map,
/* Already done in dynamic linker. */
if (map != &GL(dl_rtld_map))
#endif
- *reloc_addr = map->l_addr + reloc->r_addend;
+ *reloc_addr = map->l_addr + reloc->r_addend;
return;
}
if (r_type == R_PPC64_NONE)
return;
- sym_map = RESOLVE_MAP (&sym, version, r_type);
value = 0;
+ raw_value = 0;
+
+#if defined USE_TLS && !defined RTLD_BOOTSTRAP
+ sym_map = RESOLVE_MAP (&sym, version, r_type);
+ raw_value = value = reloc->r_addend;
if (sym_map)
+ if (sym)
{
- if (sym)
- value = sym_map->l_addr + sym->st_value;
- value += reloc->r_addend;
+ raw_value += sym->st_value;
+ value = raw_value + sym_map->l_addr;
}
+#else
+ sym_map = RESOLVE_MAP (&sym, version, r_type);
+ if (sym_map)
+ {
+ if (sym)
+ {
+ raw_value = sym->st_value + sym_map->l_addr;
+ }
+ value = raw_value + reloc->r_addend;
+ }
+#endif
switch (r_type)
{
case R_PPC64_ADDR64:
case R_PPC64_GLOB_DAT:
- *reloc_addr = value;
+ *reloc_addr = value;
return;
+
+#if defined USE_TLS && (!defined RTLD_BOOTSTRAP || USE___THREAD)
+
+ case R_PPC64_DTPMOD64:
+#ifdef RTLD_BOOTSTRAP
+ /* During startup the dynamic linker is always index 1. */
+ *reloc_addr = 1;
+#else
+ /* Get the information from the link map returned by the
+ resolv function. */
+ if (sym_map != NULL)
+ {
+ *reloc_addr = sym_map->l_tls_modid;
+ }
+#endif
+ return;
+
+ case R_PPC64_TPREL64:
+#ifdef RTLD_BOOTSTRAP
+ *reloc_addr = raw_value + map->l_tls_offset - 0x7010;
+#else
+ if (sym_map)
+ {
+ CHECK_STATIC_TLS (map, sym_map);
+ *reloc_addr = raw_value + sym_map->l_tls_offset - 0x7010;
+ }
+#endif
+ return;
+
+ case R_PPC64_DTPREL64:
+#ifndef RTLD_BOOTSTRAP
+ /* During relocation all TLS symbols are defined and used.
+ Therefore the offset is already correct. */
+ *reloc_addr = raw_value - 0x8000;
+#endif
+ return;
+#endif
case R_PPC64_JMP_SLOT:
@@ -601,15 +663,61 @@ elf_machine_rela (struct link_map *map,
value, 0xfffc);
break;
+ case R_PPC64_TPREL16_LO_DS:
+ if (dont_expect ((value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_TPREL16_LO_DS",
+ reloc_addr, sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
+ case R_PPC64_DTPREL16_LO_DS:
+ if (dont_expect ((value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_DTPREL16_LO_DS",
+ reloc_addr, sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
+ case R_PPC64_GOT_TPREL16_LO_DS:
+ if (dont_expect ((value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_GOT_TPREL16_LO_DS",
+ reloc_addr, sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
+ case R_PPC64_GOT_DTPREL16_LO_DS:
+ if (dont_expect ((value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_GOT_DTPREL16_LO_DS",
+ reloc_addr, sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
case R_PPC64_ADDR16_LO:
+ case R_PPC64_TPREL16_LO:
+ case R_PPC64_DTPREL16_LO:
+ case R_PPC64_GOT_TLSGD16_LO:
+ case R_PPC64_GOT_TLSLD16_LO:
*(Elf64_Half *) reloc_addr = PPC_LO (value);
break;
case R_PPC64_ADDR16_HI:
+ case R_PPC64_TPREL16_HI:
+ case R_PPC64_DTPREL16_HI:
+ case R_PPC64_GOT_TPREL16_HI:
+ case R_PPC64_GOT_DTPREL16_HI:
+ case R_PPC64_GOT_TLSGD16_HI:
+ case R_PPC64_GOT_TLSLD16_HI:
*(Elf64_Half *) reloc_addr = PPC_HI (value);
break;
case R_PPC64_ADDR16_HA:
+ case R_PPC64_TPREL16_HA:
+ case R_PPC64_DTPREL16_HA:
+ case R_PPC64_GOT_TLSGD16_HA:
+ case R_PPC64_GOT_TLSLD16_HA:
*(Elf64_Half *) reloc_addr = PPC_HA (value);
break;
@@ -690,19 +798,59 @@ elf_machine_rela (struct link_map *map,
value, 0xfffc);
break;
+ case R_PPC64_TPREL16_DS:
+ if (dont_expect ((value + 0x8000) >= 0x10000 || (value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_TPREL16_DS", reloc_addr,
+ sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
+ case R_PPC64_DTPREL16_DS:
+ if (dont_expect ((value + 0x8000) >= 0x10000 || (value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_DTPREL16_DS", reloc_addr,
+ sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
+ case R_PPC64_GOT_TPREL16_DS:
+ if (dont_expect ((value + 0x8000) >= 0x10000 || (value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_GOT_TPREL16_DS", reloc_addr,
+ sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
+ case R_PPC64_GOT_DTPREL16_DS:
+ if (dont_expect ((value + 0x8000) >= 0x10000 || (value & 3) != 0))
+ _dl_reloc_overflow (map, "R_PPC64_GOT_DTPREL16_DS",
+ reloc_addr, sym, refsym);
+ *(Elf64_Half *) reloc_addr = BIT_INSERT (*(Elf64_Half *) reloc_addr,
+ value, 0xfffc);
+ break;
+
case R_PPC64_ADDR16_HIGHER:
+ case R_PPC64_TPREL16_HIGHER:
+ case R_PPC64_DTPREL16_HIGHER:
*(Elf64_Half *) reloc_addr = PPC_HIGHER (value);
break;
case R_PPC64_ADDR16_HIGHEST:
+ case R_PPC64_TPREL16_HIGHEST:
+ case R_PPC64_DTPREL16_HIGHEST:
*(Elf64_Half *) reloc_addr = PPC_HIGHEST (value);
break;
case R_PPC64_ADDR16_HIGHERA:
+ case R_PPC64_TPREL16_HIGHERA:
+ case R_PPC64_DTPREL16_HIGHERA:
*(Elf64_Half *) reloc_addr = PPC_HIGHERA (value);
break;
case R_PPC64_ADDR16_HIGHESTA:
+ case R_PPC64_TPREL16_HIGHESTA:
+ case R_PPC64_DTPREL16_HIGHESTA:
*(Elf64_Half *) reloc_addr = PPC_HIGHESTA (value);
break;
diff --git a/sysdeps/powerpc/powerpc64/dl-tls.h b/sysdeps/powerpc/powerpc64/dl-tls.h
new file mode 100644
index 0000000000..a353bbc4ae
--- /dev/null
+++ b/sysdeps/powerpc/powerpc64/dl-tls.h
@@ -0,0 +1,40 @@
+/* Thread-local storage handling in the ELF dynamic linker. PowerPC64 version.
+ Copyright (C) 2003 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ Lesser General Public License for more details.
+
+ You should have received a copy of the GNU Lesser General Public
+ License along with the GNU C Library; if not, write to the Free
+ Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+ 02111-1307 USA. */
+
+
+/* Type used for the representation of TLS information in the TOC. */
+typedef struct
+{
+ unsigned long int ti_module;
+ unsigned long int ti_offset;
+} tls_index;
+
+
+#ifdef SHARED
+
+extern void *__tls_get_addr (tls_index *ti);
+
+/* Dynamic thread vector pointers point 0x8000 past the start of each
+ TLS block. */
+# define TLS_DTV_OFFSET 0x8000
+
+# define GET_ADDR_OFFSET (ti->ti_offset + TLS_DTV_OFFSET)
+# define __TLS_GET_ADDR(__ti) (__tls_get_addr (__ti) - TLS_DTV_OFFSET)
+
+#endif
diff --git a/sysdeps/unix/sysv/linux/configure b/sysdeps/unix/sysv/linux/configure
index 721d6e7264..a1db0aab0e 100644
--- a/sysdeps/unix/sysv/linux/configure
+++ b/sysdeps/unix/sysv/linux/configure
@@ -44,7 +44,11 @@ if test "${libc_cv_linux2010+set}" = set; then
else
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
-#include "confdefs.h"
+/* confdefs.h. */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h. */
#include <linux/version.h>
#if !defined LINUX_VERSION_CODE || LINUX_VERSION_CODE < (2 *65536+ 0 *256+ 10) /* 2.0.10 */
eat flaming death
@@ -165,7 +169,11 @@ echo $ECHO_N "checking for kernel header at least $minimum_kernel... $ECHO_C" >&
abinum=`echo "$minimum_kernel.0.0.0" | sed 's/\([0-9]*\)\.\([0-9]*\)\.\([0-9]*\).*/\1,\2,\3/'`;
cat >conftest.$ac_ext <<_ACEOF
#line $LINENO "configure"
-#include "confdefs.h"
+/* confdefs.h. */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h. */
#include <linux/version.h>
#if LINUX_VERSION_CODE < $decnum
eat flaming death
diff --git a/sysdeps/unix/sysv/linux/dl-librecon.h b/sysdeps/unix/sysv/linux/dl-librecon.h
index afe1ec4b72..91535da37d 100644
--- a/sysdeps/unix/sysv/linux/dl-librecon.h
+++ b/sysdeps/unix/sysv/linux/dl-librecon.h
@@ -1,5 +1,5 @@
/* Optional code to distinguish library flavours.
- Copyright (C) 2001, 2002 Free Software Foundation, Inc.
+ Copyright (C) 2001, 2002, 2003 Free Software Foundation, Inc.
This file is part of the GNU C Library.
Contributed by Jakub Jelinek <jakub@redhat.com>, 2001.
@@ -39,7 +39,12 @@ _dl_osversion_init (char *assume_kernel)
if (!*q)
break;
}
+#if __LINUX_KERNEL_VERSION > 0
+ if (osversion < __LINUX_KERNEL_VERSION)
+ osversion = __LINUX_KERNEL_VERSION;
+#else
if (osversion)
+#endif
GL(dl_osversion) = osversion;
}